/**
 * Orbipay REST API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.9.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {

if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('logtown').getLogger('orbipay-paymentsapi-client/src/CommonUtil'));
  } 
}(this, function(logger) {
  'use strict';

  var exports = function() {
  };
	
  var MASKING_PREFIX = '**********';
  var SENSITIVE_KEYS = {  'account_number' : 3 ,  'ssn' : 0 ,  'card_cvv_number' : 0 ,  'secret' : 0 ,  'expiry_date' : 0 ,  'custom_fields' : 2   };

  exports.isNonEmptyObject = function (data) {
            return data !== null && typeof data === 'object';
  };  

  exports.getTimeStamp = function (date) {

            var pad = function (value, width) {
                var padding = '';
                while (padding.length < width - 1 && value < Math.pow(10, width - padding.length - 1))
                    padding += '0';
                return padding + value.toString();
            };

            date = date ? date : new Date();
            var offset = date.getTimezoneOffset();
            return pad(date.getFullYear(), 4)
                + '-' + pad(date.getMonth() + 1, 2)
                + '-' + pad(date.getDate(), 2)
                + ' ' + pad(date.getHours(), 2)
                + ':' + pad(date.getMinutes(), 2)
                + ':' + pad(date.getSeconds(), 2)
                + '.' + pad(date.getMilliseconds(), 3)
                + (offset > 0 ? '-' : '+')
                + pad(Math.floor(Math.abs(offset) / 60), 2)
                + ':' + pad(Math.abs(offset) % 60, 2);
  };

  exports.isJsonString = function (str) {
        try {
                JSON.parse(str);
            } catch (e) {
		logger.warn('Error while parsing the string to JSON  in isJsonString');
                return false;
            }
        return true;
  };

  exports.parseJSON = function (string) {
            var json;
            try {
                json = JSON.parse(string);
            } catch (e) {
                logger.error('Error while parsing the string to JSON', e);
            }
            return json;
        };

  exports.maskSensitiveInfo = function (key, value) {
    var maskedValue = value;
    var keyToBeMasked;
    var visibleDataLength;

    for(var field in SENSITIVE_KEYS){
        if(field === key){
            keyToBeMasked=field;
            visibleDataLength= SENSITIVE_KEYS[field];
        }
    }

    if (keyToBeMasked !== undefined && keyToBeMasked!== null) {
        if(exports.isNonEmptyObject(value)){
		    if (value && typeof value === 'object') {
			return exports.maskObject(value, visibleDataLength);
		    }
	    }
		if (value && value.length > 0) {
		    if(visibleDataLength >= value.length){
		        maskedValue = MASKING_PREFIX;
		    }
		    else {
		        maskedValue = MASKING_PREFIX + maskedValue.substring(value.length - visibleDataLength, value.length);
		    }
		}
    }
    return maskedValue;
  };

  exports.maskObject = function (value, visibleDataLength) {
        var maskedObject = exports.cloneObject(value);
        var maskedValue;
        for (var key in maskedObject) {
            if (maskedObject.hasOwnProperty(key)) {
                if (maskedObject[key] && maskedObject[key].length > 0) {
                    if(visibleDataLength >= value.length){
                        maskedValue = MASKING_PREFIX;
                    }
                    else {
                        maskedValue = MASKING_PREFIX + maskedObject[key].substring(maskedObject[key].length - visibleDataLength, maskedObject[key].length);
                    }
                }
                maskedObject[key] = maskedValue;
            }
        }
        return maskedObject;
  };

  exports.cloneObject = function(mainObj){
      var objCopy={};
      try{
          if(mainObj!==null) {
              objCopy = JSON.parse(JSON.stringify(mainObj));
          }
      }catch (e){
          logger.error('Error while cloning the object', e);
          logger.error(e);
      }
      return objCopy;
  };

  exports.maskSensitiveFormParams = function (logArray) {
            var maskedFormParam = '';
            for (var i = 0; i < logArray.length; i++) {
                var pair = logArray[i];
                var key = pair['key'];
                var maskedValue = pair['value'];
                var keyToBeMasked = null;
                var visibleDataLength = null;

                for(var field in SENSITIVE_KEYS){
                    if(field === key){
                        keyToBeMasked=field;
                        visibleDataLength= SENSITIVE_KEYS[field];
                    }
                }

                if (keyToBeMasked !== undefined && keyToBeMasked!== null) {
                    if (maskedValue && maskedValue.length > 0) {
                        maskedValue = MASKING_PREFIX + maskedValue.substring(maskedValue.length - visibleDataLength, maskedValue.length);
                    }
                }
                maskedFormParam = maskedFormParam + key + '=' + maskedValue + '&';
            }
            return maskedFormParam.substring(0, maskedFormParam.length - 1);
  };

  exports.getMaskedJsonString = function (object) {
            var maskedString = '';
            try {
                if (object && typeof object === 'object') {
                    maskedString = JSON.stringify(object, exports.maskSensitiveInfo);
                }
            } catch (e) {
                logger.error(e);
            }
            return maskedString;
  };

  exports.getValuesFromMultiMap = function (multiMap, key, isMultipleValuesAllowed) {
            var response;
            if (multiMap && multiMap.map && multiMap.map.hasOwnProperty(key)) {
                if (Array.isArray(multiMap.map[key]) && multiMap.map[key].length > 0) {
                    if (isMultipleValuesAllowed) {
                        response = multiMap.map[key];
                    } else {
                        response = multiMap.map[key][0];
                    }
                } else {
                    multiMap.map.hasOwnProperty(key);
                }
            }
            return response;
  };

  exports.prototype.deserialize = function deserialize(response, returnType) {
        if (response === null || returnType === null) {
            return null;
        }
        // Rely on SuperAgent for parsing response body.
        // See http://visionmedia.github.io/superagent/#parsing-response-bodies
        var data = response.body;
        if (data === null || (typeof data === 'object' && typeof data.length === 'undefined' && !Object.keys(data).length)) {
            // SuperAgent does not always produce a body; use the unparsed response as a fallback
            data = response.text;
        }
        return exports.convertToType(data, returnType);
  };

  exports.convertToType = function (data, type) {
        if (data === null || data === undefined)
            return data;

        switch (type) {
            case 'Boolean':
                return Boolean(data);
            case 'Integer':
                return parseInt(data, 10);
            case 'Number':
                return parseFloat(data);
            case 'String':
                return String(data);
            case 'Date':
                return this.parseDate(String(data));
            case 'Blob':
                return data;
            default:
                if (type === Object) {
                    // generic object, return directly
                    return data;
                } else if (typeof type === 'function' && typeof type.constructFromObject === 'function') {
                    // for model type like: User
                    return type.constructFromObject(data);
                } else if (Array.isArray(type)) {
                    // for array type like: ['String']
                    var itemType = type[0];
                    return data.map(function (item) {
                        return exports.convertToType(item, itemType);
                    });
                } else if (typeof type === 'object') {
                    // for plain object type like: {'String': 'Integer'}
                    var keyType, valueType;
                    for (var typeKey in type) {
                        if (type.hasOwnProperty(typeKey)) {
                            keyType = typeKey;
                            valueType = type[typeKey];
                            break;
                        }
                    }
                    var result = {};
                    for (var dataKey in data) {
                        if (data.hasOwnProperty(dataKey)) {
                            var key = exports.convertToType(dataKey, keyType);
                            result[key] = exports.convertToType(data[dataKey], valueType);
                        }
                    }
                    return result;
                } else {
                    // for unknown type, return the data directly
                    return data;
                }
        }
  };

  exports.isFunction = function (data) {
            return data && {}.toString.call(data) === '[object Function]';
  };

  return exports;

}));
