/**
 * Orbipay REST API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.9.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'models/ErrorResponseVo', 'models/PaymentResponse'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../models/ErrorResponseVo'), require('../models/PaymentResponse'));
  } else {
    // Browser globals (root is window)
    if (!root.OrbipayPaymentsapiClient) {
      root.OrbipayPaymentsapiClient = {};
    }
    root.OrbipayPaymentsapiClient.FeePaymentApi = factory(root.OrbipayPaymentsapiClient.ApiClient, root.OrbipayPaymentsapiClient.ErrorResponseVo, root.OrbipayPaymentsapiClient.PaymentResponse);
  }
}(this, function(ApiClient, ErrorResponseVo, PaymentResponse) {
  'use strict';

  /**
   * FeePayment service.
   * @module api/FeePaymentApi
   * @version 1.9.1
   */

  /**
   * Constructs a new FeePaymentApi. 
   * @alias module:api/FeePaymentApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the retrieveFeePayment operation.
     * @callback module:api/FeePaymentApi~retrieveFeePaymentCallback
     * @param {String} error Error message, if any.
     * @param {module:models/PaymentResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get FeePayment
     * The API is used to retrieve the details of a fee payment by id.
     * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
     * @param {String} client_key The unique identifier assigned by OrbiPay to the client.
     * @param {module:models/String} product The product identifier corresponding to the API.
     * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
     * @param {String} idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by OrbiPay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
     * @param {String} requestor The identifier for the requestor of the API, in OrbiPay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the OrbiPay generated customer id, for user, it would be the OrbiPay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
     * @param {module:models/String} requestor_type Type of the requestor of the API.
     * @param {String} id_fee The unique identifier assigned by OrbiPay to the FeePayment.
     * @param {String} id_customer The unique identifier assigned by OrbiPay to the customer.
     * @param {Object} opts Optional parameters
     * @param {String} opts.x_opay_headers Intended for the future use.
     * @param {module:api/FeePaymentApi~retrieveFeePaymentCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:models/PaymentResponse}
     */
    this.retrieveFeePayment = function(channel, client_key, product, timestamp, idempotent_request_key, requestor, requestor_type, id_fee, id_customer, opts, callback) {
      opts = opts || {};
      var postBody = null;

      var pathParams = {
        'ID_FEE': id_fee,
        'ID_CUSTOMER': id_customer
      };
      var queryParams = {
      };
      var headerParams = {
        'channel': channel,
        'client_key': client_key,
        'product': product,
        'timestamp': timestamp,
        'idempotent_request_key': idempotent_request_key,
        'requestor': requestor,
        'requestor_type': requestor_type,
        'X-OPAY-Headers': opts['x_opay_headers']
      };
      var formParams = {
      };

      var authNames = ['ApiKeyAuth'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = PaymentResponse;

      return this.apiClient.callApi(
        '/customers/{ID_CUSTOMER}/fees/{ID_FEE}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    };
  };

  return exports;
}));
