/**
 * Orbipay REST API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.9.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'models/AddFundingAccountRequest', 'models/DeleteFundingAccountRequest', 'models/DeleteResponse', 'models/ErrorResponseVo', 'models/FundingAccountResponse', 'models/FundingAccountsResponse', 'models/ReplaceFundingAccountRequest', 'models/UpdateFundingAccountRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../models/AddFundingAccountRequest'), require('../models/DeleteFundingAccountRequest'), require('../models/DeleteResponse'), require('../models/ErrorResponseVo'), require('../models/FundingAccountResponse'), require('../models/FundingAccountsResponse'), require('../models/ReplaceFundingAccountRequest'), require('../models/UpdateFundingAccountRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.OrbipayPaymentsapiClient) {
      root.OrbipayPaymentsapiClient = {};
    }
    root.OrbipayPaymentsapiClient.FundingAccountApi = factory(root.OrbipayPaymentsapiClient.ApiClient, root.OrbipayPaymentsapiClient.AddFundingAccountRequest, root.OrbipayPaymentsapiClient.DeleteFundingAccountRequest, root.OrbipayPaymentsapiClient.DeleteResponse, root.OrbipayPaymentsapiClient.ErrorResponseVo, root.OrbipayPaymentsapiClient.FundingAccountResponse, root.OrbipayPaymentsapiClient.FundingAccountsResponse, root.OrbipayPaymentsapiClient.ReplaceFundingAccountRequest, root.OrbipayPaymentsapiClient.UpdateFundingAccountRequest);
  }
}(this, function(ApiClient, AddFundingAccountRequest, DeleteFundingAccountRequest, DeleteResponse, ErrorResponseVo, FundingAccountResponse, FundingAccountsResponse, ReplaceFundingAccountRequest, UpdateFundingAccountRequest) {
  'use strict';

  /**
   * FundingAccount service.
   * @module api/FundingAccountApi
   * @version 1.9.1
   */

  /**
   * Constructs a new FundingAccountApi. 
   * @alias module:api/FundingAccountApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the createFundingAccount operation.
     * @callback module:api/FundingAccountApi~createFundingAccountCallback
     * @param {String} error Error message, if any.
     * @param {module:models/FundingAccountResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add Funding Account
     * This API is used to add a funding account for the customer. The funding account is available for servicing all the customer accounts the customer holds. An exhaustive set of account types are supported as funding accounts as indicated in the field account_subtype. ABA routing number and account sub-type are mandatory for bank accounts. Expiry date, address fields and Card CVV are required for card accounts.
     * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
     * @param {String} client_key The unique identifier assigned by Orbipay to the client.
     * @param {module:models/String} product The product identifier corresponding to the API.
     * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
     * @param {String} idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
     * @param {module:models/String} requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center.
     * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent.
     * @param {String} id_customer The unique identifier assigned by Orbipay to the customer.
     * @param {module:models/AddFundingAccountRequest} add_funding_account_request JSON containing all the attributes of the Funding account to be added to customer.
     * @param {Object} opts Optional parameters
     * @param {String} opts.x_opay_headers Intended for the future use.
     * @param {module:api/FundingAccountApi~createFundingAccountCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:models/FundingAccountResponse}
     */
    this.createFundingAccount = function(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, requestor, id_customer, add_funding_account_request, opts, callback) {
      opts = opts || {};
      var postBody = add_funding_account_request;

      var pathParams = {
        'ID_CUSTOMER': id_customer
      };
      var queryParams = {
      };
      var headerParams = {
        'channel': channel,
        'client_key': client_key,
        'product': product,
        'timestamp': timestamp,
        'idempotent_request_key': idempotent_request_key,
        'requestor_type': requestor_type,
        'requestor': requestor,
        'X-OPAY-Headers': opts['x_opay_headers']
      };
      var formParams = {
      };

      var authNames = ['ApiKeyAuth'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = FundingAccountResponse;

      return this.apiClient.callApi(
        '/customers/{ID_CUSTOMER}/fundingaccounts', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    };

    /**
     * Callback function to receive the result of the deleteFundingAccount operation.
     * @callback module:api/FundingAccountApi~deleteFundingAccountCallback
     * @param {String} error Error message, if any.
     * @param {module:models/DeleteResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Funding Account
     * The Delete Funding Account API is used to delete the funding account of a customer. All pending payments made with that account are cancelled upon deletion of the funding account.
     * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
     * @param {String} client_key The unique identifier assigned by Orbipay to the client.
     * @param {module:models/String} product The product identifier corresponding to the API.
     * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
     * @param {String} idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
     * @param {module:models/String} requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center.
     * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent.
     * @param {String} id_funding_account The unique identifier assigned by Orbipay to the Funding Account.
     * @param {String} id_customer The unique identifier assigned by Orbipay to the customer.
     * @param {module:models/DeleteFundingAccountRequest} delete_funding_account_request Details of account to be deleted.
     * @param {Object} opts Optional parameters
     * @param {String} opts.x_opay_headers Intended for the future use.
     * @param {module:api/FundingAccountApi~deleteFundingAccountCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:models/DeleteResponse}
     */
    this.deleteFundingAccount = function(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, requestor, id_funding_account, id_customer, delete_funding_account_request, opts, callback) {
      opts = opts || {};
      var postBody = delete_funding_account_request;

      var pathParams = {
        'ID_FUNDING_ACCOUNT': id_funding_account,
        'ID_CUSTOMER': id_customer
      };
      var queryParams = {
      };
      var headerParams = {
        'channel': channel,
        'client_key': client_key,
        'product': product,
        'timestamp': timestamp,
        'idempotent_request_key': idempotent_request_key,
        'requestor_type': requestor_type,
        'requestor': requestor,
        'X-OPAY-Headers': opts['x_opay_headers']
      };
      var formParams = {
      };

      var authNames = ['ApiKeyAuth'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = DeleteResponse;

      return this.apiClient.callApi(
        '/customers/{ID_CUSTOMER}/fundingaccounts/{ID_FUNDING_ACCOUNT}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    };

    /**
     * Callback function to receive the result of the replaceFundingAccount operation.
     * @callback module:api/FundingAccountApi~replaceFundingAccountCallback
     * @param {String} error Error message, if any.
     * @param {module:models/FundingAccountResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Replace Funding Account
     * The API is used to replace the funding account details. The type of the funding account cannot be replaced. In other words, a card account cannot be replaced to a bank account and vice versa. CVV is mandatory to make any change to a card account.Replacing a funding account updates the account information on all pending payments made using that account but does not change the details on payments that have been completed.
     * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
     * @param {String} client_key The unique identifier assigned by Orbipay to the client.
     * @param {module:models/String} product The product identifier corresponding to the API.
     * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
     * @param {String} idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
     * @param {module:models/String} requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center.
     * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent.
     * @param {String} id_funding_account The unique identifier assigned by Orbipay to the Funding Account.
     * @param {String} id_customer The unique identifier assigned by Orbipay to the customer.
     * @param {module:models/ReplaceFundingAccountRequest} replace_funding_account_request JSON containing all the attributes of the Funding account to be replaced.
     * @param {Object} opts Optional parameters
     * @param {String} opts.x_opay_headers Intended for the future use.
     * @param {module:api/FundingAccountApi~replaceFundingAccountCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:models/FundingAccountResponse}
     */
    this.replaceFundingAccount = function(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, requestor, id_funding_account, id_customer, replace_funding_account_request, opts, callback) {
      opts = opts || {};
      var postBody = replace_funding_account_request;

      var pathParams = {
        'ID_FUNDING_ACCOUNT': id_funding_account,
        'ID_CUSTOMER': id_customer
      };
      var queryParams = {
      };
      var headerParams = {
        'channel': channel,
        'client_key': client_key,
        'product': product,
        'timestamp': timestamp,
        'idempotent_request_key': idempotent_request_key,
        'requestor_type': requestor_type,
        'requestor': requestor,
        'X-OPAY-Headers': opts['x_opay_headers']
      };
      var formParams = {
      };

      var authNames = ['ApiKeyAuth'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = FundingAccountResponse;

      return this.apiClient.callApi(
        '/customers/{ID_CUSTOMER}/fundingaccounts/{ID_FUNDING_ACCOUNT}/replacement', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    };

    /**
     * Callback function to receive the result of the retrieveFundingAccount operation.
     * @callback module:api/FundingAccountApi~retrieveFundingAccountCallback
     * @param {String} error Error message, if any.
     * @param {module:models/FundingAccountResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Funding Account
     * The Get Funding Account API is used to retrieve the details of the funding account based on the id.
     * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
     * @param {String} client_key The unique identifier assigned by Orbipay to the client.
     * @param {module:models/String} product The product identifier corresponding to the API.
     * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
     * @param {String} idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
     * @param {module:models/String} requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center.
     * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent.
     * @param {String} id_funding_account The unique identifier assigned by Orbipay to the Funding Account.
     * @param {String} id_customer The unique identifier assigned by Orbipay to the customer.
     * @param {Object} opts Optional parameters
     * @param {String} opts.x_opay_headers Intended for the future use.
     * @param {module:api/FundingAccountApi~retrieveFundingAccountCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:models/FundingAccountResponse}
     */
    this.retrieveFundingAccount = function(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, requestor, id_funding_account, id_customer, opts, callback) {
      opts = opts || {};
      var postBody = null;

      var pathParams = {
        'ID_FUNDING_ACCOUNT': id_funding_account,
        'ID_CUSTOMER': id_customer
      };
      var queryParams = {
      };
      var headerParams = {
        'channel': channel,
        'client_key': client_key,
        'product': product,
        'timestamp': timestamp,
        'idempotent_request_key': idempotent_request_key,
        'requestor_type': requestor_type,
        'requestor': requestor,
        'X-OPAY-Headers': opts['x_opay_headers']
      };
      var formParams = {
      };

      var authNames = ['ApiKeyAuth'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = FundingAccountResponse;

      return this.apiClient.callApi(
        '/customers/{ID_CUSTOMER}/fundingaccounts/{ID_FUNDING_ACCOUNT}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    };

    /**
     * Callback function to receive the result of the retrieveFundingAccounts operation.
     * @callback module:api/FundingAccountApi~retrieveFundingAccountsCallback
     * @param {String} error Error message, if any.
     * @param {module:models/FundingAccountsResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve Funding Accounts
     * This API is used to retrieve all the funding accounts associated with a customer. Accounts can be filtered using the account number, the ABA routing number (for bank accounts), the account status, account type, account sub-type and others mentioned below. The results are sorted based on their last_modified_time in descending order.
     * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
     * @param {String} client_key The unique identifier assigned by Orbipay to the client.
     * @param {module:models/String} product The product identifier corresponding to the API.
     * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
     * @param {String} idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
     * @param {module:models/String} requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center.
     * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent.
     * @param {String} id_customer The unique identifier assigned by Orbipay to the customer.
     * @param {Object} opts Optional parameters
     * @param {String} opts.x_opay_headers Intended for the future use.
     * @param {String} opts.page_size The maximum number of objects returned in the query.
     * @param {String} opts.account_number The Account Number to get details of.
     * @param {Array.<module:models/String>} opts.status The status of the funding account in Orbipay. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2....
     * @param {String} opts.aba_routing_number The ABA/Routing number for the bank account.
     * @param {Array.<module:models/String>} opts.account_type The type of the funding account. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2....
     * @param {module:models/String} opts.account_subtype The sub type of the funding account. This is derived by Orbipay in the case of card funding accounts. It needs to be passed when adding or editing a DDA/bank account.
     * @param {module:api/FundingAccountApi~retrieveFundingAccountsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:models/FundingAccountsResponse}
     */
    this.retrieveFundingAccounts = function(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, requestor, id_customer, opts, callback) {
      opts = opts || {};
      var postBody = null;

      var pathParams = {
        'ID_CUSTOMER': id_customer
      };
      var queryParams = {
        'page_size': opts['page_size']
      };
      var headerParams = {
        'channel': channel,
        'client_key': client_key,
        'product': product,
        'timestamp': timestamp,
        'idempotent_request_key': idempotent_request_key,
        'requestor_type': requestor_type,
        'requestor': requestor,
        'X-OPAY-Headers': opts['x_opay_headers']
      };
      var formParams = {
        'account_number': opts['account_number'],
        'status': this.apiClient.buildCollectionParam(opts['status'], 'multi'),
        'aba_routing_number': opts['aba_routing_number'],
        'account_type': this.apiClient.buildCollectionParam(opts['account_type'], 'multi'),
        'account_subtype': opts['account_subtype']
      };

      var authNames = ['ApiKeyAuth'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = ['application/json'];
      var returnType = FundingAccountsResponse;

      return this.apiClient.callApi(
        '/customers/{ID_CUSTOMER}/fundingaccounts/lists', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    };

    /**
     * Callback function to receive the result of the retrieveFundingAccountsPage operation.
     * @callback module:api/FundingAccountApi~retrieveFundingAccountsPageCallback
     * @param {String} error Error message, if any.
     * @param {module:models/FundingAccountsResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve Funding Accounts Page
     * This API is used to get a page/set of funding accounts based on the lookup id, 
     * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
     * @param {String} client_key The unique identifier assigned by Orbipay to the client.
     * @param {module:models/String} product The product identifier corresponding to the API.
     * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
     * @param {String} idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
     * @param {module:models/String} requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center.
     * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent.
     * @param {String} id_customer The unique identifier assigned by Orbipay to the customer.
     * @param {String} query_id query id of the Retrieve/Search Accounts lookup.
     * @param {Object} opts Optional parameters
     * @param {String} opts.x_opay_headers Intended for the future use.
     * @param {String} opts.page_size The maximum number of objects returned in the query.
     * @param {String} opts.from_index To fetch the next set of objects that start after this object
     * @param {String} opts.to_index To fetch the previous set of objects that end at this object
     * @param {module:api/FundingAccountApi~retrieveFundingAccountsPageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:models/FundingAccountsResponse}
     */
    this.retrieveFundingAccountsPage = function(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, requestor, id_customer, query_id, opts, callback) {
      opts = opts || {};
      var postBody = null;

      var pathParams = {
        'ID_CUSTOMER': id_customer
      };
      var queryParams = {
        'page_size': opts['page_size'],
        'query_id': query_id,
        'from_index': opts['from_index'],
        'to_index': opts['to_index']
      };
      var headerParams = {
        'channel': channel,
        'client_key': client_key,
        'product': product,
        'timestamp': timestamp,
        'idempotent_request_key': idempotent_request_key,
        'requestor_type': requestor_type,
        'requestor': requestor,
        'X-OPAY-Headers': opts['x_opay_headers']
      };
      var formParams = {
      };

      var authNames = ['ApiKeyAuth'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = FundingAccountsResponse;

      return this.apiClient.callApi(
        '/customers/{ID_CUSTOMER}/fundingaccounts/lists', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    };

    /**
     * Callback function to receive the result of the updateFundingAccount operation.
     * @callback module:api/FundingAccountApi~updateFundingAccountCallback
     * @param {String} error Error message, if any.
     * @param {module:models/FundingAccountResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Funding Account
     * The API is used to edit the funding account details. The type of the funding account cannot be changed. In other words, a card account cannot be changed to a bank account and vice versa. The sub-type of a bank account can be changed. For e.g., a saving account can be updated to a money market account. However, the sub-type cannot be updated for a card account. CVV is mandatory to make any change to a card account. The Id of the funding account gets updated to a new value if the account number is updated. Editing a funding account updates the account information on all pending payments made using that account but does not change the details on payments that have been completed.
     * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
     * @param {String} client_key The unique identifier assigned by Orbipay to the client.
     * @param {module:models/String} product The product identifier corresponding to the API.
     * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
     * @param {String} idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
     * @param {module:models/String} requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center.
     * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent.
     * @param {String} id_funding_account The unique identifier assigned by Orbipay to the Funding Account.
     * @param {String} id_customer The unique identifier assigned by Orbipay to the customer.
     * @param {module:models/UpdateFundingAccountRequest} update_funding_account_request JSON containing all the attributes of the Funding account to be updated.
     * @param {Object} opts Optional parameters
     * @param {String} opts.x_opay_headers Intended for the future use.
     * @param {module:api/FundingAccountApi~updateFundingAccountCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:models/FundingAccountResponse}
     */
    this.updateFundingAccount = function(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, requestor, id_funding_account, id_customer, update_funding_account_request, opts, callback) {
      opts = opts || {};
      var postBody = update_funding_account_request;

      var pathParams = {
        'ID_FUNDING_ACCOUNT': id_funding_account,
        'ID_CUSTOMER': id_customer
      };
      var queryParams = {
      };
      var headerParams = {
        'channel': channel,
        'client_key': client_key,
        'product': product,
        'timestamp': timestamp,
        'idempotent_request_key': idempotent_request_key,
        'requestor_type': requestor_type,
        'requestor': requestor,
        'X-OPAY-Headers': opts['x_opay_headers']
      };
      var formParams = {
      };

      var authNames = ['ApiKeyAuth'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = FundingAccountResponse;

      return this.apiClient.callApi(
        '/customers/{ID_CUSTOMER}/fundingaccounts/{ID_FUNDING_ACCOUNT}', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    };
  };

  return exports;
}));
