/**
 * Orbipay REST API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.9.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.OrbipayPaymentsapiClient) {
      root.OrbipayPaymentsapiClient = {};
    }
    root.OrbipayPaymentsapiClient.CustomerAccountSnapshotResponse = factory(root.OrbipayPaymentsapiClient.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The CustomerAccountSnapshotResponse model module.
   * @module models/CustomerAccountSnapshotResponse
   * @version 1.9.1
   */

  /**
   * Constructs a new <code>CustomerAccountSnapshotResponse</code>.
   * The customer account against which the payment is being made.
   * @alias module:models/CustomerAccountSnapshotResponse
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>CustomerAccountSnapshotResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:models/CustomerAccountSnapshotResponse} obj Optional instance to populate.
   * @return {module:models/CustomerAccountSnapshotResponse} The populated <code>CustomerAccountSnapshotResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('account_number')) {
        obj['account_number'] = ApiClient.convertToType(data['account_number'], 'String');
      }
      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
    }
    return obj;
  };

  /**
   * The number or reference that a customer uses to identify the customer's account.
   * @member {String} account_number
   */
  exports.prototype['account_number'] = undefined;
  /**
   * Id is a unique identifier assigned to the account in Orbipay.
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * This URL fetches the customer account details.
   * @member {String} url
   */
  exports.prototype['url'] = undefined;



  return exports;
}));


