/**
 * Orbipay REST API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.9.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.OrbipayPaymentsapiClient) {
      root.OrbipayPaymentsapiClient = {};
    }
    root.OrbipayPaymentsapiClient.RecordedPaymentFundingAccount = factory(root.OrbipayPaymentsapiClient.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The RecordedPaymentFundingAccount model module.
   * @module models/RecordedPaymentFundingAccount
   * @version 1.9.1
   */

  /**
   * Constructs a new <code>RecordedPaymentFundingAccount</code>.
   * @alias module:models/RecordedPaymentFundingAccount
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>RecordedPaymentFundingAccount</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:models/RecordedPaymentFundingAccount} obj Optional instance to populate.
   * @return {module:models/RecordedPaymentFundingAccount} The populated <code>RecordedPaymentFundingAccount</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('account_number')) {
        obj['account_number'] = ApiClient.convertToType(data['account_number'], 'String');
      }
      if (data.hasOwnProperty('issuer_name')) {
        obj['issuer_name'] = ApiClient.convertToType(data['issuer_name'], 'String');
      }
    }
    return obj;
  };

  /**
   * The number or reference that a customer uses to identify the funding account. or last 4 digits of account number.
   * @member {String} account_number
   */
  exports.prototype['account_number'] = undefined;
  /**
   * The name of the authority that has issued the account.
   * @member {String} issuer_name
   */
  exports.prototype['issuer_name'] = undefined;



  return exports;
}));


